/*
Copyright (C)  2006  Daniele Zelante

This file is part of comf.

comf is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

comf is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with comf; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/*@LICENSE*/
// $Id$

#ifndef COMF_TYPES_HXX
#define COMF_TYPES_HXX


#include "defs.hxx"

COMF_NS_BEGIN


class Serializable;
class Entity;
class ConstSegment;
class Segment;
class DynamicSegment;
class Memory;
class Exception;

class BOStorage;
class BIStorage;
class TOStorage;
class TIStorage;

class TextOutput;
class TextInput;
class TextOutputFile;
class TextInputFile;

class Socket;

class LibInfo;
class LibInfoList;

class FileMappingDynamicSegment;


//! Destruct retry callback, used to trap exceptions in destructors
typedef bool (*t_destructretry)(int error, int fd, const char * scope);


COMF_NS_END

#endif
